`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/30/2023 12:56:05 PM
// Design Name: 
// Module Name: register
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module register #(
        parameter width = 16          
    )(
        input clk,
        input rst,
        input [width-1:0] in,
        input we,
        input oe,
        output [width-1:0] out
    );
    
    reg [width-1:0] data;
    
    always@(posedge clk) begin
        if(rst)
            data <= 0;
        else
            if(we)
                data <= in;
    end
    
    assign out = oe ? data : 0;
    
endmodule
